﻿/* $Id: I2L_problems.j,v 1.10 2003/10/08 09:05:53 richard Exp $ */

TACTIC TheoremForward (thm) IS CUTIN (ALT thm (RESOLVE thm))

TACTIC TheoremForwardOrBackward(thm) IS
    WHEN    
        (LETHYP _A 
            (ALT    (TheoremForward (WITHHYPSEL (WITHARGSEL thm)))))
        (LETHYPS _As
            (Fail ("At present I2L Jape can't deal with multiple antecedent selections when applying theorems. Sorry.\
                    \\nCancel one of them and try again.")))
        (LETGOAL _A
            (ALT (WITHARGSEL thm) 
                (RESOLVE (WITHARGSEL thm)) 
                (TheoremForward (WITHARGSEL thm))
                (Fail   "Theorem application failed -- tell Richard")))
        (LETOPENSUBGOAL G _A 
            (Fail ("Error in I2L Jape (open subgoal in TheoremForwardOrBackward). Tell Richard.")))
        (LETOPENSUBGOALS _As
            (ALERT  ("There is more than one unproved conclusion in the proof. Please select one – \
                        \or select an antecedent – to show \
                        \Jape where to apply the theorem.")
                    ("OK", STOP) 
                    ("Huh?", Explainantecedentandconclusionwords)))
        (ALERT  "The proof is finished -- there are no unproved conclusions left."
                ("OK", STOP) 
                ("Huh?", Explainunprovedconclusionwords))

/* These theorems are all stated without an explicit left context Γ. That is possible because, in I2L_rules.j,
 * we declared a WEAKEN structure rule: Jape will automatically discard any unmatched left-context
 * formulae.
 */
  
/* Panels are declared in reverse order because the GUIs,  quite reasonably, create panels in the order requested.
 * Thus the last you ask for is the last created, and appears at the front of the stack.
 */

CONJECTUREPANEL "Ej. 1: Practica 3"
    THEOREM IS ∀ x.(P(x) → Q(x)) ⊦ ∀ x.P(x) → ∀ x.Q(x)
    THEOREM IS ∃ x.¬ P(x) ⊦ ¬ ∀ x.P(x)
    THEOREM IS ∀ x.P(x) ⊦ ∀ y.P(y)
    THEOREM IS ∀ x.(P(x) → Q(x)) ⊦ 
               (∀ x.¬ Q(x)) → (∀ x.¬ P(x))
    THEOREM IS ∀ x.(P(x) → ¬ Q(x)) ⊦
               ¬(∃ x.(P(x) ∧ Q(x)))

    THEOREM IS ∀ x.∀ y.P(x,y) ⊦ ∀ u.∀ v.P(u,v)
    THEOREM IS ∃ x.∃ y.P(x,y) ⊦ ∃ u.∃ v.P(u,v)
    THEOREM IS ∃ x.∀ y.P(x,y) ⊦ ∀ y.∃ x.P(x,y)

    THEOREM IS ∃ x.(P(a) → Q(x)) ⊦ P(a) → ∃ x.Q(x)
    THEOREM IS P(a) → ∃ x.Q(x), actual i ⊦ ∃ x.(P(a) → Q(x))
    THEOREM IS ∃ x.P(x) → Q(a) ⊦ ∀ x.(P(x) → Q(a))
    THEOREM IS ∀ x.(P(x) → Q(a)), actual i ⊦ ∃ x.(P(x) → Q(a))

    THEOREM IS ∀ x.P(x) ∨ ∀ x.Q(x) ⊦ ∀ x.(P(x) ∨ Q(x))
    THEOREM IS ∃ x.(P(x) ∧ Q(x)) ⊦ ∃ x.P(x) ∧ ∃ x.Q(x)
    THEOREM IS ∀ x.∀ y.(P(y) → Q(x)) ⊦ ∃ y.P(y) → ∀ x.Q(x)
    THEOREM IS ¬ ∀ x.¬ P(x), actual j ⊦ ∃ x.P(x)
    THEOREM IS ∀ x.¬ P(x) ⊦ ¬ ∃ x.P(x)
    THEOREM IS ∃ x.P(x) ⊦ ¬ ∀ x.¬ P(x)
    THEOREM IS P(a) → ∀ x.Q(x) ⊦ ∀ x.(P(a) → Q(x))
    THEOREM IS ∀ x.∀ y.∀ z.(R(x,y) ∧ R(y,z) → R(x,z)),
               ∀ x.¬ R(x,x)
               ⊦ ∀ x.∀ y.(R(x,y) → ¬ R(y,x))
    THEOREM IS ∀ x.(P(x) ∨ Q(x)),
               ∃ x.¬ Q(x),
               ∀ x.(R(x) → ¬ P(x))
               ⊦ ∃ x.¬ R(x)
    THEOREM IS ∀ x.(P(x) → (Q(x) ∨ R(x))),
               ¬ ∃ x.(P(x) ∧ R(x))
               ⊦ ∀ x.(P(x) → Q(x))
    THEOREM IS ∃ x.∃ y.(R(x,y) ∨ R(y,x)) ⊦ ∃ x.∃ y.R(x,y)

    BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
END

CONJECTUREPANEL "Ej. 2: Ejemplos de clase"
    THEOREM IS  actual j, P(j), ∀x.(P(x)→Q(x)) ⊦ Q(j)
    THEOREM IS  ∀x.(P(x)→Q(x)) ⊦ ∀y.P(y)→∀z.Q(z)
    THEOREM IS  ∀x.(P(x)→Q(x)), ∀y.(Q(y)→R(y)) ⊦ ∀z.(P(z)→R(z))
    THEOREM IS  ∀x.P(x)∧∀y.Q(y) ⊦ ∀z.(P(z)∧Q(z))
    THEOREM IS  ∀x.(P(x)∧Q(x)) ⊦ ∀y.P(y)∧∀z.Q(z)
    THEOREM IS  ∀x.(P(x)→Q(x)), ∃y.P(y) ⊦ ∃z.Q(z)
    THEOREM IS  ∃x.(P(x)∧Q(x)) ⊦ ∃y.P(y)∧∃z.Q(z)
    THEOREM IS  ∃x.P(x)∨∃y.Q(y) ⊦ ∃z.(P(z)∨Q(z))
    THEOREM IS  ∃x.(P(x)∨Q(x)) ⊦ ∃y.P(y)∨∃z.Q(z)
    THEOREM IS  actual j, ∀x.P(x) ⊦ ∃y.P(y)
    THEOREM IS  ∀x.P(x) ⊦ ¬∃y.¬P(y)
    THEOREM IS   ¬∃y.¬P(y) ⊦  ∀x.P(x)
    THEOREM IS  ∃x.P(x) ⊦ ¬∀y.¬P(y)
    THEOREM IS  ∃x.¬P(x) ⊦ ¬∀y.P(y)
    THEOREM IS  ∀x.¬P(x) ⊦ ¬∃y.P(y)
    THEOREM IS  ¬∃x.P(x) ⊦ ∀y.¬P(y)
    
    THEOREM IS actual j, actual k, ∃x.¬P(x) ⊦ ∃y.(P(y)→P(j)∧P(k))

    THEOREM IS actual j, actual k ⊦ ∃x.(P(x)→P(j)∧P(k))

    BUTTON Apply IS apply TheoremForwardOrBackward COMMAND
END
